package simse.modelbuilder.graphicsbuilder;

import java.io.Serializable;

import java.util.Hashtable;
import java.util.Vector;

import simse.modelbuilder.startstatebuilder.CreatedObjects;
import simse.modelbuilder.startstatebuilder.SimSEObject;

public class Graphics implements Serializable {
  static final long serialVersionUID = -4491734853266613463L;
	/* 
	 * maps SimSEObjects (keys) from the start state to the filename of the
	 * associated image file (String):
	 */
	private Hashtable<SimSEObject, String> startStateObjsToImgFilenames; 

	/* 
	 * maps SimSEObjects (keys) from the create objects rules to the filename of 
	 * the associated image file (String):
	 */
	private Hashtable<SimSEObject, String> ruleObjsToImgFilenames; 

	public Graphics() {
		startStateObjsToImgFilenames = new Hashtable<SimSEObject, String>();
		ruleObjsToImgFilenames = new Hashtable<SimSEObject, String>();
	}
	
  /*
   * Erases all current graphics and fills it with all of the graphics in the 
   * parameter
   */
  public void copyGraphics(Graphics newGraphics) {
  	startStateObjsToImgFilenames.clear();
  	ruleObjsToImgFilenames.clear();
  	startStateObjsToImgFilenames.putAll(
  			newGraphics.getStartStateObjsToImgFilenames());
  	ruleObjsToImgFilenames.putAll(newGraphics.getRuleObjsToImgFilenames());
  }
	
	public Hashtable<SimSEObject, String> getStartStateObjsToImgFilenames() {
		return startStateObjsToImgFilenames;
	}
	
	public Hashtable<SimSEObject, String> getRuleObjsToImgFilenames() {
		return ruleObjsToImgFilenames;
	}
}
